## saga 8.5.0+dfsg

=== saga-gis/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

# Policy CMP0043 introduced in cmake version 3.0 IGNORES the use of COMPILE_DEFINITIONS
# suffixed variables, e.g. COMPILE_DEFINITIONS_DEBUG
# since cmake version >= 2.8.10 COMPILE_DEFINITIONS can be set by generator expressions.
if (POLICY CMP0043)
	cmake_policy(SET CMP0043 NEW)
endif (POLICY CMP0043)

# define project name and its description
project(saga)
message(STATUS "folder: ${PROJECT_NAME}")
set(TOP_PROJECT ${PROJECT_NAME})
string(TOLOWER ${TOP_PROJECT} TOP_PROJECT_LOWER)
set(PROJECT_DESCRIPTION "SAGA - System for Automated Geoscientific Analyses")

# Set a default build type for single-configuration cmake generators if
# no build type is set.
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
	message(STATUS "Set default build type to Release")
	set(CMAKE_BUILD_TYPE Release)
endif()

if(MSVC)
	set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "" FORCE)

	option(DEPS_FROM_ENVARS "Library locations from environment" ON)

	option(PARALLEL_BUILD "Multi-processor compilation (/MP)" ON)
	if(PARALLEL_BUILD)
		add_definitions(/MP)
	endif()

	# default debug configuration to use: 'Program Database for Edit And Continue (/ZI)'
	set(CMAKE_C_FLAGS_DEBUG             "/MDd /ZI /Ob0 /Od /RTC1"       CACHE STRING "" FORCE)
	set(CMAKE_CXX_FLAGS_DEBUG           "/MDd /ZI /Ob0 /Od /RTC1"       CACHE STRING "" FORCE)
	set(CMAKE_EXE_LINKER_FLAGS_DEBUG    "/debug /INCREMENTAL /LTCG:OFF" CACHE STRING "" FORCE)
	set(CMAKE_MODULE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL /LTCG:OFF" CACHE STRING "" FORCE)
	set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL /LTCG:OFF" CACHE STRING "" FORCE)
else()
	# Unix Flags
	set(CMAKE_CXX_FLAGS_RELEASE 		"-O3 -Wall -DNDEBUG"			CACHE STRING "" FORCE)
	set(CMAKE_CXX_FLAGS_DEBUG 			"-Og -ggdb -Wall"				CACHE STRING "" FORCE)
endif()

# options
option(WITH_GUI "Build SAGA with GUI" ON)
option(WITH_TOOLS "Build SAGA with tools" ON)
option(OpenMP_SUPPORT "Compile with OpenMP optimizations" ON)
#option(WITH_LINK_TESTER "Check to enable testing if tools are successfully linking" OFF)

# include version and debianize
include(version.cmake)

# include shared definitions and scripts
include(cmake/shared/require-cpp11.cmake)
include(cmake/shared/enable_warnings.cmake)
include(cmake/shared/windows_version_info.cmake)

# Use GNU install dirs to support multiarch
include(cmake/modules/GNUInstallDirs.cmake)

# clang uses this compile commands for the language server protocol
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) 

# create windows resouce file
set(windows_version_rc "${CMAKE_BINARY_DIR}/win_version_info.rc")
gen_win_version_resource("${PROJECT_NAME}" "${windows_version_rc}"
	${SAGA_VERSION_MAJOR} ${SAGA_VERSION_MINOR} ${SAGA_VERSION_PATCH} ${GIT_COUNT}
	${SAGA_VERSION_FULL_STRING})

# include the generated header files
include_directories("${PROJECT_BINARY_DIR}")


# add local models to search path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

# find wxWidgets
#find_package(wxWidgets REQUIRED)
#include("${wxWidgets_USE_FILE}")

# compile with OpenMP optimizations
if(OpenMP_SUPPORT)
	find_package(OpenMP QUIET REQUIRED)
	if(OPENMP_FOUND)
		message(STATUS "compile with OpenMP optimizations")
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   ${OpenMP_C_FLAGS}")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
		if(APPLE)
			set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   ${OpenMP_C_FLAGS}   -I${OpenMP_C_INCLUDE_DIR}")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -I${OpenMP_CXX_INCLUDE_DIR}")
			cmake_path(GET OpenMP_libomp_LIBRARY PARENT_PATH OpenMP_LIBRARY_DIR)
			set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS}    -L${OpenMP_LIBRARY_DIR} -lomp")
			set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -L${OpenMP_LIBRARY_DIR} -lomp")
		endif(APPLE)
	else()
		message(STATUS "OpenMP not found!")
	endif(OPENMP_FOUND)
endif(OpenMP_SUPPORT)

# add files to dummy target to show in IDE
file(GLOB CMAKE_FILES "cmake/*.cmake" "cmake/modules/*.cmake")
file(GLOB SHARED_CMAKE_FILES "cmake/shared/*.cmake")
add_custom_target(saga-other-files SOURCES
	.gitignore
	src/gpl.txt
	src/lgpl.txt
	src/install.txt
	cmake/Config.cmake
	cmake/config.h.cmake
	${CMAKE_FILES}
	${SHARED_CMAKE_FILES}
)

# configure config.h
include(cmake/Config.cmake)
Config()

# add subdirectories
add_subdirectory(src)

# in case some automated tests will be written
#option(BUILD_TESTING "Build tests for saga-gis" ON)
#if(BUILD_TESTING)
#	 enable tests
#	enable_testing(true)
#	add_subdirectory(tests)
#endif()

=== saga-gis/src/accessories/CMakeLists.txt ===
project(accessories)
message(STATUS "folder: ${PROJECT_NAME}")

#add_subdirectory(toolchains)
install(DIRECTORY toolchains DESTINATION share/saga
	FILES_MATCHING PATTERN "*.xml")

=== saga-gis/src/saga_core/saga_api/CMakeLists.txt ===
project(saga_api)

message(STATUS "project: ${PROJECT_NAME}")

# define headers
set(SAGA_API_PUBLIC_HEADERS
	api_core.h
	data_manager.h
	dataobject.h
	datetime.h
	geo_tools.h
	grid.h
	grids.h
	grid_pyramid.h
	mat_tools.h
	metadata.h
	parameters.h
	pointcloud.h
	saga_api.h
	shapes.h
	table_dbase.h
	table.h
	table_value.h
	tin.h
	tool.h
	tool_library.h
)

# define sources
set(SAGA_API_SOURCES
	api_callback.cpp
	api_colors.cpp
	api_core.cpp
	api_file.cpp
	api_memory.cpp
	api_string.cpp
	api_translator.cpp
	data_manager.cpp
	dataobject.cpp
	datetime.cpp
	geo_classes.cpp
	geo_functions.cpp
	grid.cpp
	grid_io.cpp
	grid_memory.cpp
	grid_operation.cpp
	grid_pyramid.cpp
	grid_system.cpp
	grids.cpp
	kdtree.cpp
	mat_formula.cpp
	mat_grid_radius.cpp
	mat_indexing.cpp
	mat_matrix.cpp
	mat_regression.cpp
	mat_regression_multiple.cpp
	mat_regression_weighted.cpp
	mat_spline.cpp
	mat_tools.cpp
	mat_trend.cpp
	metadata.cpp
	parameter.cpp
	parameter_data.cpp
	parameters.cpp
	pointcloud.cpp
	projections.cpp
	quadtree.cpp
	saga_api.cpp
	shape.cpp
	shape_line.cpp
	shape_part.cpp
	shape_point.cpp
	shape_points.cpp
	shape_polygon.cpp
	shapes.cpp
	shapes_io.cpp
	shapes_ogis.cpp
	shapes_search.cpp
	shapes_selection.cpp
	table.cpp
	table_dbase.cpp
	table_io.cpp
	table_record.cpp
	table_selection.cpp
	tin.cpp
	tin_elements.cpp
	tin_triangulation.cpp
	tool.cpp
	tool_chain.cpp
	tool_grid.cpp
	tool_grid_interactive.cpp
	tool_interactive.cpp
	tool_interactive_base.cpp
	tool_library.cpp
	tool_library_interface.cpp
	tool_summary.cpp
	api_core.h
	data_manager.h
	dataobject.h
	datetime.h
	geo_tools.h
	grid.h
	grid_pyramid.h
	mat_tools.h
	metadata.h
	nanoflann.hpp
	parameters.h
	pointcloud.h
	saga_api.h
	shapes.h
	table.h
	table_dbase.h
	table_value.h
	tin.h
	tool.h
	tool_chain.h
	tool_library.h
)

#________________________________________
option(WITH_CLIPPER_ONE "Check to make SAGA API use older Clipper1 instead of newer Clipper2 (expects at least C++ 17)" ON)

if(WITH_CLIPPER_ONE)
	set(SAGA_API_SOURCES
		${SAGA_API_SOURCES}
		clipper.cpp
		clipper.hpp
		shapes_polygons.cpp
	)
else()
	set(SAGA_API_SOURCES
		${SAGA_API_SOURCES}
		clipper.engine.cpp
		clipper.offset.cpp
		clipper.h
		clipper.core.h
		clipper.engine.h
		clipper.minkowski.h
		clipper.offset.h
		shapes_clipper.cpp
	)
endif()

#________________________________________
option(WITH_MRMR "Check to include mRMR code (Minimum Redundancy Feature Selection, incompatible with Debian licensing)" OFF)

if(WITH_MRMR)
	set(SAGA_API_SOURCES
		${SAGA_API_SOURCES}
		mat_mRMR.cpp
	)
endif()

#________________________________________
add_library(saga_api SHARED
	${SAGA_API_SOURCES}
	${SAGA_API_PUBLIC_HEADERS} # just cosmetic, show headers in IDE
)

target_include_directories(saga_api INTERFACE "${saga_core_include_dir}")

find_package(wxWidgets COMPONENTS base net xml html REQUIRED)
target_link_libraries(saga_api PRIVATE ${wxWidgets_LIBRARIES})

if(MSVC) # windows msvc
	target_compile_definitions(saga_api PUBLIC -D_SAGA_MSW -DUNICODE)
else() # unix like systems
	target_compile_definitions(saga_api PUBLIC -D_SAGA_LINUX)
	target_compile_definitions(saga_api PRIVATE -D${MTOOLSPATH} -D${MSHAREPATH})
	set_target_properties(saga_api PROPERTIES COMPILE_FLAGS -fPIC)
endif()

target_compile_definitions(saga_api PUBLIC -D_TYPEDEF_BYTE -D_TYPEDEF_WORD)
target_compile_definitions(saga_api PRIVATE -D_SAGA_API_EXPORTS)

if(WITH_MRMR)
	target_compile_definitions(saga_api PUBLIC -DWITH_MRMR)
endif()

# set version number for library
set_target_properties(saga_api PROPERTIES
	VERSION ${SAGA_VERSION_STRING}
	SOVERSION ${SAGA_VERSION_MAJOR}
)

# where to install the library
install(TARGETS saga_api DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${SAGA_API_PUBLIC_HEADERS} DESTINATION include/saga/saga_api)

if(MSVC)
	string(REPLACE "/" "\\" SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/")
	add_custom_command(TARGET saga_api POST_BUILD
		COMMAND IF NOT EXIST "$(OutDir)include" MKDIR "$(OutDir)include"
		COMMAND IF EXIST "$(OutDir)include\\saga_api" RMDIR /S/Q "$(OutDir)include\\saga_api"
		COMMAND MKDIR    "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}api_core.h"     "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}data_manager.h" "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}dataobject.h"   "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}datetime.h"     "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}geo_tools.h"    "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}grid.h"         "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}grid_pyramid.h" "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}grids.h"        "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}mat_tools.h"    "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}metadata.h"     "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}parameters.h"   "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}pointcloud.h"   "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}saga_api.h"     "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}shapes.h"       "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}table.h"        "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}table_value.h"  "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}tin.h"          "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}tool.h"         "$(OutDir)include\\saga_api"
		COMMAND COPY "${SOURCE_DIR}tool_library.h" "$(OutDir)include\\saga_api"
	)
endif()

#-#-#-#-#-# SWIG / Python #-#-#-#-#-#
option(WITH_PYTHON "Uncheck to not try to Build the SAGA API for Python." ON)
if(WITH_PYTHON)
	add_subdirectory(saga_api_python)
endif()

=== saga-gis/src/saga_core/saga_cmd/CMakeLists.txt ===
project(saga_cmd)
message(STATUS "project: ${PROJECT_NAME}")

# define sources
set(SAGA_CMD_SOURCES
	callback.cpp
	callback.h
	config.cpp
	config.h
	tool.cpp
	tool.h
	saga_cmd.cpp
)

add_executable(saga_cmd ${SAGA_CMD_SOURCES})

# link saga_api
target_link_libraries(saga_cmd saga_api)

# find and use wxWidgeds
find_package(wxWidgets COMPONENTS base REQUIRED QUIET)
target_link_libraries(saga_cmd ${wxWidgets_LIBRARIES})

if(MSVC) # windows msvc
	target_compile_definitions(saga_cmd PUBLIC -D_SAGA_MSW -DUNICODE)

else() # unix like systems
	set_target_properties(saga_cmd PROPERTIES COMPILE_FLAGS -fPIC)
	target_compile_definitions(saga_cmd PUBLIC -D_SAGA_LINUX)
	target_compile_definitions(saga_cmd PRIVATE -D${MTOOLSPATH} -D${MSHAREPATH})
endif()

# add man page
add_subdirectory(man)

# where to install the binary
install(TARGETS saga_cmd DESTINATION bin)

=== saga-gis/src/saga_core/saga_gdi/CMakeLists.txt ===
project(saga_gdi)
message(STATUS "project: ${PROJECT_NAME}")

# define sources
set(SAGA_GDI_SOURCES
	3d_view_canvas.cpp
	3d_view_dialog.cpp
	3d_view_panel.cpp
	3d_view_projector.cpp
	sgdi_controls.cpp
	sgdi_diagram.cpp
	sgdi_dialog.cpp
	sgdi_helper.cpp
	sgdi_layout_items.cpp
	saga_gdi.cpp
	3d_view.h
	3d_view_tools.h
	saga_gdi.h
	sgdi_controls.h
	sgdi_core.h
	sgdi_diagram.h
	sgdi_dialog.h
	sgdi_helper.h
	sgdi_layout_items.h
)
set(SAGA_GDI_PUBLIC_HEADERS
	3d_view.h
	3d_view_tools.h
	saga_gdi.h
	sgdi_controls.h
	sgdi_core.h
	sgdi_diagram.h
	sgdi_dialog.h
	sgdi_helper.h
	sgdi_layout_items.h
)

add_library(saga_gdi SHARED
	${SAGA_GDI_SOURCES}
	${SAGA_GDI_PUBLIC_HEADERS} # just cosmetic, show headers in IDE
)

# link saga_api
target_link_libraries(saga_gdi saga_api)

# include directories of wxWidgets are already present
find_package(wxWidgets REQUIRED QUIET)
target_link_libraries(saga_gdi ${wxWidgets_LIBRARIES})

if(MSVC) # windows msvc
	target_compile_definitions(saga_gdi PUBLIC -D_SAGA_MSW -DUNICODE)

else() # unix like systems
	set_target_properties(saga_cmd PROPERTIES COMPILE_FLAGS -fPIC)
	target_compile_definitions(saga_gdi PUBLIC -D_SAGA_LINUX)
endif()

# define for compiling libraries
target_compile_definitions(${PROJECT_NAME} PRIVATE -D_SAGA_GDI_EXPORTS)

# set version number for library
set_target_properties(saga_gdi PROPERTIES
	VERSION ${SAGA_VERSION_STRING}
	SOVERSION ${SAGA_VERSION_MAJOR})

# where to install the binary
install(TARGETS saga_gdi DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${SAGA_GDI_PUBLIC_HEADERS} DESTINATION include/saga/saga_gdi)

if(MSVC)
	string(REPLACE "/" "\\" SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/")
	add_custom_command(TARGET saga_gdi POST_BUILD
		COMMAND IF NOT EXIST "$(OutDir)include" MKDIR "$(OutDir)include"
		COMMAND IF EXIST "$(OutDir)include\\saga_gdi" RMDIR /S/Q "$(OutDir)include\\saga_gdi"
		COMMAND MKDIR    "$(OutDir)include\\saga_gdi"
		COMMAND COPY "${SOURCE_DIR}3d_view.h"           "$(OutDir)include\\saga_gdi"
		COMMAND COPY "${SOURCE_DIR}3d_view_tools.h"     "$(OutDir)include\\saga_gdi"
		COMMAND COPY "${SOURCE_DIR}saga_gdi.h"          "$(OutDir)include\\saga_gdi"
		COMMAND COPY "${SOURCE_DIR}sgdi_core.h"         "$(OutDir)include\\saga_gdi"
		COMMAND COPY "${SOURCE_DIR}sgdi_diagram.h"      "$(OutDir)include\\saga_gdi"
		COMMAND COPY "${SOURCE_DIR}sgdi_dialog.h"       "$(OutDir)include\\saga_gdi"
		COMMAND COPY "${SOURCE_DIR}sgdi_helper.h"       "$(OutDir)include\\saga_gdi"
		COMMAND COPY "${SOURCE_DIR}sgdi_layout_items.h" "$(OutDir)include\\saga_gdi"
	)
endif()

=== saga-gis/src/saga_core/saga_gui/CMakeLists.txt ===
project(saga_gui)
message(STATUS "project: ${PROJECT_NAME}")

# define sources
set(SAGA_GUI_SOURCES
	active.cpp
	active_attributes.cpp
	active_attributes_control.cpp
	active_description.cpp
	active_history.cpp
	active_info.cpp
	active_legend.cpp
	active_parameters.cpp
	callback.cpp
	data_source.cpp
	data_source_files.cpp
	data_source_odbc.cpp
	data_source_pgsql.cpp
	dlg_about.cpp
	dlg_about_logo.cpp
	dlg_base.cpp
	dlg_choices.cpp
	dlg_colors.cpp
	dlg_colors_control.cpp
	dlg_list.cpp
	dlg_parameters.cpp
	dlg_table.cpp
	dlg_table_control.cpp
	dlg_text.cpp
	helper.cpp
	info.cpp
	info_messages.cpp
	parameters_control.cpp
	parameters_properties.cpp
	project.cpp
	res_commands.cpp
	res_controls.cpp
	res_dialogs.cpp
	res_images.cpp
	saga.cpp
	saga_frame.cpp
	saga_frame_droptarget.cpp
	view_base.cpp
	view_histogram.cpp
	view_layout.cpp
	view_layout_control.cpp
	view_layout_info.cpp
	view_map.cpp
	view_map_3d.cpp
	view_map_3d_panel.cpp
	view_map_control.cpp
	view_ruler.cpp
	view_scatterplot.cpp
	view_table.cpp
	view_table_control.cpp
	view_table_data.cpp
	view_table_diagram.cpp
	wksp.cpp
	wksp_base_control.cpp
	wksp_base_item.cpp
	wksp_base_manager.cpp
	wksp_data_control.cpp
	wksp_data_item.cpp
	wksp_data_layers.cpp
	wksp_data_manager.cpp
	wksp_data_menu_file.cpp
	wksp_data_menu_files.cpp
	wksp_grid.cpp
	wksp_grid_manager.cpp
	wksp_grid_system.cpp
	wksp_grids.cpp
	wksp_layer.cpp
	wksp_layer_classify.cpp
	wksp_layer_legend.cpp
	wksp_map.cpp
	wksp_map_basemap.cpp
	wksp_map_buttons.cpp
	wksp_map_control.cpp
	wksp_map_dc.cpp
	wksp_map_graticule.cpp
	wksp_map_layer.cpp
	wksp_map_manager.cpp
	wksp_pointcloud.cpp
	wksp_pointcloud_manager.cpp
	wksp_shapes.cpp
	wksp_shapes_edit.cpp
	wksp_shapes_line.cpp
	wksp_shapes_manager.cpp
	wksp_shapes_point.cpp
	wksp_shapes_points.cpp
	wksp_shapes_polygon.cpp
	wksp_shapes_type.cpp
	wksp_table.cpp
	wksp_table_manager.cpp
	wksp_tin.cpp
	wksp_tin_manager.cpp
	wksp_tool.cpp
	wksp_tool_control.cpp
	wksp_tool_library.cpp
	wksp_tool_manager.cpp
	wksp_tool_menu.cpp
	active.h
	active_attributes.h
	active_attributes_control.h
	active_description.h
	active_history.h
	active_info.h
	active_legend.h
	active_parameters.h
	callback.h
	data_source.h
	data_source_files.h
	data_source_odbc.h
	data_source_pgsql.h
	dlg_about.h
	dlg_about_logo.h
	dlg_base.h
	dlg_choices.h
	dlg_colors.h
	dlg_colors_control.h
	dlg_list.h
	dlg_parameters.h
	dlg_table.h
	dlg_table_control.h
	dlg_text.h
	helper.h
	info.h
	info_messages.h
	parameters_control.h
	parameters_properties.h
	project.h
	res_commands.h
	res_controls.h
	res_dialogs.h
	res_images.h
	saga.h
	saga_frame.h
	saga_frame_droptarget.h
	view_base.h
	view_histogram.h
	view_layout.h
	view_layout_control.h
	view_layout_info.h
	view_map.h
	view_map_3d.h
	view_map_3d_panel.h
	view_map_control.h
	view_ruler.h
	view_scatterplot.h
	view_table.h
	view_table_control.h
	view_table_data.h
	view_table_diagram.h
	wksp.h
	wksp_base_control.h
	wksp_base_item.h
	wksp_base_manager.h
	wksp_data_control.h
	wksp_data_item.h
	wksp_data_layers.h
	wksp_data_manager.h
	wksp_data_menu_file.h
	wksp_data_menu_files.h
	wksp_grid.h
	wksp_grid_manager.h
	wksp_grid_system.h
	wksp_grids.h
	wksp_layer.h
	wksp_layer_classify.h
	wksp_layer_legend.h
	wksp_map.h
	wksp_map_basemap.h
	wksp_map_buttons.h
	wksp_map_control.h
	wksp_map_dc.h
	wksp_map_graticule.h
	wksp_map_layer.h
	wksp_map_manager.h
	wksp_pointcloud.h
	wksp_pointcloud_manager.h
	wksp_shapes.h
	wksp_shapes_line.h
	wksp_shapes_manager.h
	wksp_shapes_point.h
	wksp_shapes_points.h
	wksp_shapes_polygon.h
	wksp_shapes_type.h
	wksp_table.h
	wksp_table_manager.h
	wksp_tin.h
	wksp_tin_manager.h
	wksp_tool.h
	wksp_tool_control.h
	wksp_tool_library.h
	wksp_tool_manager.h
	wksp_tool_menu.h
)

add_executable(saga_gui ${SAGA_GUI_SOURCES} res/saga_gui.rc)

# link needed saga libraries
target_link_libraries(saga_gui saga_api saga_gdi)

# find and link wxWidgets libraries
find_package(wxWidgets COMPONENTS adv aui base core html net propgrid xml REQUIRED QUIET)
target_link_libraries(saga_gui ${wxWidgets_LIBRARIES})

# add compile definition needed
if(MSVC)
	option(WITH_GUI_TABBED_MDI "GUI with Tabbed MDI" OFF)
	if(WITH_GUI_TABBED_MDI)
		target_compile_definitions(saga_gui PRIVATE MDI_TABBED)
	endif()

	target_compile_definitions(saga_gui PUBLIC -D_SAGA_MSW -DUNICODE)
	target_link_options(saga_gui PRIVATE /SUBSYSTEM:WINDOWS)
	
	option(WITH_DPI_AWARENESS "GUI as DPI aware application" OFF)
	if(WITH_DPI_AWARENESS)
		message(STATUS "GUI as DPI aware application")
		target_compile_definitions(saga_gui PRIVATE DPI_AWARE)
		set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} /MANIFEST:NO")
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /MANIFEST:NO")
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /MANIFEST:NO")
	else()
		message(STATUS "GUI without DPI awareness")
	endif()
	
else() # unix like systems
	set_target_properties(saga_gui PROPERTIES COMPILE_FLAGS -fPIC)
	target_compile_definitions(saga_gui PUBLIC -D_SAGA_LINUX)
	target_compile_definitions(saga_gui PRIVATE -D${MTOOLSPATH} -D${MSHAREPATH})
endif()

find_package(Git)
if(GIT_FOUND)
	IF(EXISTS "${CMAKE_SOURCE_DIR}/../.git")
		execute_process(
			COMMAND git log -1 --format=%h
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE GIT_HASH
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
		message("git hash: ${GIT_HASH} to ${PROJECT_SOURCE_DIR}/git_hash.h")
	else()
		message("not a git repository, git hash not found")
	endif()
else()
	message("git executable not found")
endif(GIT_FOUND)
configure_file("${PROJECT_SOURCE_DIR}/git_hash.h.in" "${PROJECT_SOURCE_DIR}/git_hash.h" @ONLY)

set(COMPILER "${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")
add_definitions(-DCOMPILER="${COMPILER}")

# add man page
add_subdirectory(man)
# add res directory
add_subdirectory(res)

# where to install the binary
install(TARGETS saga_gui DESTINATION bin)

if(MSVC)
	string(REPLACE "/" "\\" SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/")
	add_custom_command(TARGET saga_gui POST_BUILD
		COMMAND COPY "${SOURCE_DIR}res\\saga.rus.txt" "$(OutDir)saga.rus.txt"
		COMMAND COPY "${SOURCE_DIR}res\\saga.ger.txt" "$(OutDir)saga.ger.txt"
		COMMAND COPY "${SOURCE_DIR}res\\saga.lng.txt" "$(OutDir)saga.lng.txt"
		COMMAND COPY "${SOURCE_DIR}res\\saga.bra.txt" "$(OutDir)saga.bra.txt"
		COMMAND COPY "${SOURCE_DIR}res\\saga.ger.txt" "$(OutDir)saga.ger.txt"
		COMMAND COPY "${SOURCE_DIR}res\\saga.rus.txt" "$(OutDir)saga.rus.txt"
		COMMAND COPY "${SOURCE_DIR}res\\saga_tip.txt" "$(OutDir)saga_gui.tip"
		COMMAND COPY "${SOURCE_DIR}res\\saga_srs.txt" "$(OutDir)saga_prj.srs"
		COMMAND COPY "${SOURCE_DIR}res\\saga_dic.txt" "$(OutDir)saga_prj.dic"
		COMMAND IF NOT EXIST "$(OutDir)tools" MKDIR "$(OutDir)tools"
		COMMAND IF EXIST "$(OutDir)tools\\toolchains" RMDIR /S/Q "$(OutDir)tools\\toolchains"
		COMMAND MKDIR    "$(OutDir)tools\\toolchains"
		COMMAND XCOPY /C/Q/Y/H "${SOURCE_DIR}..\\..\\accessories\\toolchains\\*.xml" "$(OutDir)\\tools\\toolchains"
	#	COMMAND COPY "${SOURCE_DIR}..\\..\\accessories\\toolchains\\*.xml" "$(OutDir)\\tools\\toolchains"
	)
endif()

=== saga-gis/src/tools/develop/CMakeLists.txt ===
add_subdirectory(dev_tools)
add_subdirectory(dev_exercises)

=== saga-gis/src/tools/grid/CMakeLists.txt ===
add_subdirectory(grid_analysis)
add_subdirectory(grid_calculus)
add_subdirectory(grid_calculus_bsl)
add_subdirectory(grid_filter)
add_subdirectory(grid_gridding)
add_subdirectory(grid_spline)
add_subdirectory(grid_tools)
add_subdirectory(grid_visualisation)
add_subdirectory(grids_tools)

=== saga-gis/src/saga_core/saga_api/saga_api_python/CMakeLists.txt ===
# define headers
set(SAGA_API_PUBLIC_HEADERS
	api_core.h
	data_manager.h
	dataobject.h
	datetime.h
	geo_tools.h
	grid.h
	grids.h
	grid_pyramid.h
	mat_tools.h
	metadata.h
	parameters.h
	pointcloud.h
	saga_api.h
	shapes.h
	table_dbase.h
	table.h
	table_value.h
	tin.h
	tool.h
	tool_library.h
)

find_package(SWIG QUIET)
if(SWIG_FOUND)
	message(STATUS "SWIG for Python found")
    find_package(Python COMPONENTS Interpreter Development)
	if(Python_FOUND)
#		project(saga_api_python)

		message(STATUS "project: ${PROJECT_NAME}")

		message(STATUS "Python found")

		if(POLICY CMP0078)	# SWIG: use standard target name.
		  cmake_policy(SET CMP0078 NEW)
		endif()

		if(POLICY CMP0086)	# SWIG: use SWIG_MODULE_NAME property.
		  cmake_policy(SET CMP0086 NEW)
		endif()

		include(UseSWIG)

        include_directories("${Python_INCLUDE_DIRS}")
        include_directories("${Python_INCLUDE_DIRS}/../PC")	# msvc builds
		include_directories("..")

		set(CMAKE_SWIG_FLAGS "-D_SAGA_PYTHON -D_SWIG_WCHAR")

		set_property(SOURCE ../saga_api.i PROPERTY CPLUSPLUS ON)
		set_property(SOURCE ../saga_api.i PROPERTY COMPILE_OPTIONS "-includeall")

		swig_add_library(saga_api_python LANGUAGE Python SOURCES ../saga_api.i)

		set_property(TARGET saga_api_python PROPERTY OUTPUT_NAME saga_api)

		swig_link_libraries(saga_api_python saga_api)
		swig_link_libraries(saga_api_python ${Python_LIBRARIES})


        if(EXISTS ${Python_SITELIB})
            message(STATUS "Python site-packages: ${PYTHON_SITELIB}")
            install(TARGETS saga_api_python DESTINATION ${Python_SITELIB})
            install(FILES ${CMAKE_BINARY_DIR}/src/saga_core/saga_api/saga_api_python/saga_api.py DESTINATION ${Python_SITELIB})
            install(FILES ${CMAKE_SOURCE_DIR}/src/accessories/python/examples/saga_helper.py DESTINATION ${Python_SITELIB})
		endif()
	endif()
endif()

=== saga-gis/src/tools/db/db_odbc/CMakeLists.txt ===
if(WITH_TOOLS)
	if(MSVC)
		project(db_odbc)
		include(../../CMakePluginTemplate.cmake)	# load common tool template
		target_link_libraries(${PROJECT_NAME} odbc32 odbccp32)
	else()
		find_package(ODBC)	# ubuntu package unixodbc-dev
		if(ODBC_FOUND)
			project(db_odbc)
			include(../../CMakePluginTemplate.cmake)	# load common tool template
			target_include_directories(${PROJECT_NAME} PRIVATE "${ODBC_INCLUDE_DIRS}")
			target_link_libraries(${PROJECT_NAME} "${ODBC_LIBRARIES}")
		endif()
	endif()		
endif()

=== saga-gis/src/tools/develop/dev_exercises/CMakeLists.txt ===
option(WITH_EXCERCISES "Check to create build targets for SAGA development tools" OFF)

if(WITH_EXCERCISES)
	project(dev_exercises)

	include(../../CMakePluginTemplate.cmake) # load common tool template
endif()

=== saga-gis/src/tools/grid/grid_analysis/CMakeLists.txt ===
if(WITH_TOOLS)
	project(grid_analysis)

	# load common tool template
	include(../../CMakePluginTemplate.cmake )
endif()

=== debian/changelog ===
saga (8.5.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Drop libvigraimpex-dev build dependency (dead upstream, RC buggy).

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 04 Jan 2023 12:31:42 +0100

saga (8.5.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 26 Dec 2022 09:17:29 +0100

=== debian/control ===
Source: saga
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Johan Van de Wauw <johan@gisky.be>,
           Francesco Paolo Lovergine <frankie@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-python,
               libdxflib-dev,
               libexpat-dev,
               libgdal-dev,
               libhpdf-dev,
               libproj-dev,
               libqhull-dev,
               libsvm-dev,
               libwxgtk3.2-dev,
               pkg-config,
               python3-dev,
               swig
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian-gis-team/saga
Vcs-Git: https://salsa.debian.org/debian-gis-team/saga.git
Homepage: http://www.saga-gis.org/
Rules-Requires-Root: no

Package: saga
Architecture: any
Depends: saga-common (= ${source:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: System for Automated Geoscientific Analyses
 SAGA GIS (System for Automated Geoscientific Analyses) is a free and
 open source geographic information system used for editing and
 analysing spatial data. It includes a large number of modules for the
 analysis of vector (point, line and polygon), table, grid and image
 data. Among others the package includes modules for geostatistics,
 image classification, projections, simulation of dynamic processes
 (hydrology, landscape development) and terrain analysis.
 The functionality can be accessed through a GUI, the command line or
 by using the C++ API.

Package: saga-common
Architecture: all
Depends: ${misc:Depends}
Breaks: saga (<< 2.2.5+dfsg-1~)
Replaces: saga (<< 2.2.5+dfsg-1~)
Description: SAGA GIS architecture independent files
 SAGA GIS (System for Automated Geoscientific Analyses) is a geographic
 information system used for editing and analysing spatial data.
 .
 This package contains the architecture independent files for SAGA.

Package: libsaga-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libsaga-api8 (= ${binary:Version}),
         libsaga-gdi8 (= ${binary:Version}),
         ${misc:Depends}
Suggests: saga (= ${binary:Version})
Description: SAGA GIS development files
 SAGA GIS (System for Automated Geoscientific Analyses) is a geographic
 information system used for editing and analysing spatial data.
 .
 This package contains the header files for developing with SAGA.
 Install this package if you wish to develop software that uses the SAGA API.

Package: libsaga-api8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: SAGA GIS shared libraries
 SAGA GIS (System for Automated Geoscientific Analyses) is a geographic
 information system used for editing and analysing spatial data.
 .
 This package contains the library files for developing with SAGA.

Package: libsaga-gdi8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: SAGA GIS shared library (graphical models)
 SAGA GIS (System for Automated Geoscientific Analyses) is a geographic
 information system used for editing and analysing spatial data.
 .
 This package contains the library files for developing graphical modules.

Package: python3-saga
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: saga (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: SAGA GIS Python bindings
 SAGA GIS (System for Automated Geoscientific Analyses) is a geographic
 information system used for editing and analysing spatial data.
 .
 This package contains the Python bindings to SAGA.

=== debian/rules ===
#!/usr/bin/make -f

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS += $(CPPFLAGS)

include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

%:
	dh $@ --with python3 --buildsystem=cmake --sourcedirectory=saga-gis --without autoreconf

override_dh_clean:
	dh_clean src/saga_core/saga_api/saga_api.py saga_cmd.1 saga_gui.1

override_dh_auto_configure:
	dh_auto_configure -- \
		-DWITH_SYSTEM_SVM=on \
		-DWITH_SYSTEM_DXF=on \
		-DWITH_TRIANGLE=off \
		-DWITH_FIRE_SPREADING=off

override_dh_auto_build:
	pod2man --section=1 --release=$(UPSTREAM_VERSION) --center " " debian/saga_gui.pod > saga_gui.1
	pod2man --section=1 --release=$(UPSTREAM_VERSION) --center " " debian/saga_cmd.pod > saga_cmd.1
	dh_auto_build

override_dh_auto_install:
	dh_auto_install

	# Remove executable bit from resource files
	chmod -x debian/*/usr/share/saga/*.*

	# Explicitly remove files not to be installed
	find $(CURDIR)/debian/tmp/usr/lib -name "*.pyc" -delete
	find $(CURDIR)/debian/tmp/usr/lib -name "*.pyo" -delete

override_dh_python3:
	dh_python3 --no-ext-rename

override_dh_makeshlibs:
	dh_makeshlibs -Xpython3-saga

## saga 9.1.1+dfsg

=== saga-gis/src/saga_core/saga_api/saga_api_python/CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 find_package(SWIG QUIET)
 if(SWIG_FOUND)
 	message(STATUS "SWIG for Python found")
-    find_package(Python COMPONENTS Interpreter Development)
+	find_package(Python COMPONENTS Interpreter Development)
 	if(Python_FOUND)
 #		project(saga_api_python)
 
@@ -43,8 +43,8 @@
 
 		include(UseSWIG)
 
-        include_directories("${Python_INCLUDE_DIRS}")
-        include_directories("${Python_INCLUDE_DIRS}/../PC")	# msvc builds
+		include_directories("${Python_INCLUDE_DIRS}")
+		include_directories("${Python_INCLUDE_DIRS}/../PC")	# msvc builds
 		include_directories("..")
 
 		set(CMAKE_SWIG_FLAGS "-D_SAGA_PYTHON -D_SWIG_WCHAR")
@@ -60,11 +60,18 @@
 		swig_link_libraries(saga_api_python ${Python_LIBRARIES})
 
 
-        if(EXISTS ${Python_SITELIB})
-            message(STATUS "Python site-packages: ${PYTHON_SITELIB}")
-            install(TARGETS saga_api_python DESTINATION ${Python_SITELIB})
-            install(FILES ${CMAKE_BINARY_DIR}/src/saga_core/saga_api/saga_api_python/saga_api.py DESTINATION ${Python_SITELIB})
-            install(FILES ${CMAKE_SOURCE_DIR}/src/accessories/python/examples/saga_helper.py DESTINATION ${Python_SITELIB})
+		if(EXISTS ${Python_SITELIB})
+			option(WITH_PYTHON_PKG "PySAGA package installation (if not checked API modules become installed directly in Python's site/dist-packages folder)" ON)
+			if(WITH_PYTHON_PKG)
+				message(STATUS "SAGA-Python-API installed to: ${Python_SITELIB}/PySAGA")
+				install(TARGETS saga_api_python                                                      DESTINATION ${Python_SITELIB}/PySAGA)
+				install(FILES ${CMAKE_BINARY_DIR}/src/saga_core/saga_api/saga_api_python/saga_api.py DESTINATION ${Python_SITELIB}/PySAGA)
+				install(FILES ${CMAKE_SOURCE_DIR}/src/accessories/python/__init__.py                 DESTINATION ${Python_SITELIB}/PySAGA)
+			else()
+				message(STATUS "SAGA-Python-API installed to: ${Python_SITELIB}")
+				install(TARGETS saga_api_python                                                      DESTINATION ${Python_SITELIB})
+				install(FILES ${CMAKE_BINARY_DIR}/src/saga_core/saga_api/saga_api_python/saga_api.py DESTINATION ${Python_SITELIB})
+			endif()
 		endif()
 	endif()
 endif()

=== debian/changelog ===
saga (9.1.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Export DEB_PYTHON_INSTALL_LAYOUT to fix FTBFS with CMake 3.27.0.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 26 Jul 2023 16:44:36 +0200

saga (9.1.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 11 Jul 2023 16:36:28 +0200

saga (9.0.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump debhelper compat to 13.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 05 Jul 2023 15:20:31 +0200

saga (9.0.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 11 Jun 2023 15:05:23 +0200

saga (9.0.2+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 27 May 2023 06:38:07 +0200

saga (9.0.1+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop triangle files from Files-Excluded, removed upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 21 Apr 2023 15:59:02 +0200

saga (9.0.0+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file.
  * Drop no-distutils.patch, applied upstream.
  * Rename library packages for SONAME bump.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 30 Mar 2023 20:11:07 +0200

saga (8.5.1+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.6.2, no changes.
  * Add patch to not use deprecated distutils module.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 07 Feb 2023 15:12:50 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                dh-python,
                libdxflib-dev,
                libexpat-dev,
@@ -18,7 +18,7 @@
                pkg-config,
                python3-dev,
                swig
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/saga
 Vcs-Git: https://salsa.debian.org/debian-gis-team/saga.git
 Homepage: http://www.saga-gis.org/
@@ -56,8 +56,8 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libsaga-api8 (= ${binary:Version}),
-         libsaga-gdi8 (= ${binary:Version}),
+Depends: libsaga-api9 (= ${binary:Version}),
+         libsaga-gdi9 (= ${binary:Version}),
          ${misc:Depends}
 Suggests: saga (= ${binary:Version})
 Description: SAGA GIS development files
@@ -67,7 +67,7 @@
  This package contains the header files for developing with SAGA.
  Install this package if you wish to develop software that uses the SAGA API.
 
-Package: libsaga-api8
+Package: libsaga-api9
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -80,7 +80,7 @@
  .
  This package contains the library files for developing with SAGA.
 
-Package: libsaga-gdi8
+Package: libsaga-gdi9
 Architecture: any
 Multi-Arch: same
 Section: libs

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 # Enable hardening build flags
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+export DEB_PYTHON_INSTALL_LAYOUT=deb_system
 
 CFLAGS += $(CPPFLAGS)

## saga 9.3.0+dfsg

=== debian/changelog ===
saga (9.3.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file.
  * Add patch to fix PySAGA installation path.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 19 Dec 2023 08:12:25 +0100

saga (9.2.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 14 Dec 2023 06:51:14 +0100

saga (9.2.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 06 Oct 2023 06:23:15 +0200

saga (9.1.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 05 Oct 2023 05:16:09 +0200

saga (9.1.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream releases.
  * Use execute_{before,after} instead of override in rules file.
    (closes: #1049309)
  * Enable Salsa CI.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 13 Sep 2023 05:19:55 +0200

=== debian/rules ===
--- 
+++ 
@@ -14,9 +14,6 @@
 %:
 	dh $@ --with python3 --buildsystem=cmake --sourcedirectory=saga-gis --without autoreconf
 
-override_dh_clean:
-	dh_clean src/saga_core/saga_api/saga_api.py saga_cmd.1 saga_gui.1
-
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DWITH_SYSTEM_SVM=on \
@@ -24,14 +21,11 @@
 		-DWITH_TRIANGLE=off \
 		-DWITH_FIRE_SPREADING=off
 
-override_dh_auto_build:
+execute_before_dh_auto_build:
 	pod2man --section=1 --release=$(UPSTREAM_VERSION) --center " " debian/saga_gui.pod > saga_gui.1
 	pod2man --section=1 --release=$(UPSTREAM_VERSION) --center " " debian/saga_cmd.pod > saga_cmd.1
-	dh_auto_build
 
-override_dh_auto_install:
-	dh_auto_install
-
+execute_after_dh_auto_install:
 	# Remove executable bit from resource files
 	chmod -x debian/*/usr/share/saga/*.*

## saga 9.3.1%2Bdfsg

=== saga-gis/src/saga_core/saga_api/CMakeLists.txt ===
--- 
+++ 
@@ -75,7 +75,6 @@
 	shapes.cpp
 	shapes_io.cpp
 	shapes_ogis.cpp
-	shapes_search.cpp
 	shapes_selection.cpp
 	table.cpp
 	table_dbase.cpp
@@ -103,7 +102,6 @@
 	grid_pyramid.h
 	mat_tools.h
 	metadata.h
-	nanoflann.hpp
 	parameters.h
 	pointcloud.h
 	saga_api.h
@@ -115,28 +113,34 @@
 	tool.h
 	tool_chain.h
 	tool_library.h
+	nanoflann/nanoflann.hpp
 )
 
 #________________________________________
-option(WITH_CLIPPER_ONE "Check to make SAGA API use older Clipper1 instead of newer Clipper2 (expects at least C++ 17)" ON)
+option(WITH_CLIPPER_ONE "Check to make SAGA API use older Clipper1 instead of newer Clipper2 (which expects at least C++ 17)" OFF)
 
 if(WITH_CLIPPER_ONE)
 	set(SAGA_API_SOURCES
 		${SAGA_API_SOURCES}
-		clipper.cpp
-		clipper.hpp
+		clipper1/clipper.cpp
+		clipper1/clipper.hpp
 		shapes_polygons.cpp
 	)
 else()
+	set(CMAKE_CXX_STANDARD 17)
+	set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
 	set(SAGA_API_SOURCES
 		${SAGA_API_SOURCES}
-		clipper.engine.cpp
-		clipper.offset.cpp
-		clipper.h
-		clipper.core.h
-		clipper.engine.h
-		clipper.minkowski.h
-		clipper.offset.h
+		clipper2/clipper.engine.cpp
+		clipper2/clipper.offset.cpp
+		clipper2/clipper.rectclip.cpp
+		clipper2/clipper.h
+		clipper2/clipper.core.h
+		clipper2/clipper.engine.h
+		clipper2/clipper.minkowski.h
+		clipper2/clipper.offset.h
+		clipper2/clipper.rectclip.h
 		shapes_clipper.cpp
 	)
 endif()
@@ -158,6 +162,10 @@
 )
 
 target_include_directories(saga_api INTERFACE "${saga_core_include_dir}")
+
+if(NOT WITH_CLIPPER_ONE)
+	target_include_directories(saga_api PRIVATE "${saga_core_include_dir}/saga_api")
+endif()
 
 find_package(wxWidgets COMPONENTS base net xml html REQUIRED)
 target_link_libraries(saga_api PRIVATE ${wxWidgets_LIBRARIES})
@@ -175,6 +183,11 @@
 
 if(WITH_MRMR)
 	target_compile_definitions(saga_api PUBLIC -DWITH_MRMR)
+endif()
+
+option(WITH_LIFETIME_TRACKER "Check to build with CSG_Data_Object_LifeTime_Tracker support (for special debug purposes)" OFF)
+if(WITH_LIFETIME_TRACKER)
+	target_compile_definitions(saga_api PUBLIC -DWITH_LIFETIME_TRACKER)
 endif()
 
 # set version number for library

=== saga-gis/src/tools/statistics/statistics_grid/CMakeLists.txt ===
if(WITH_TOOLS)
	project(statistics_grid)

	# load common tool template
	include(../../CMakePluginTemplate.cmake )
endif()
